Getting Started with React DropDownButton Component

Smart UI React targets React 18+ and current Node LTS for tooling; use TypeScript templates when you want typed props and events.

Demo source (Smart UI repo): react/source/dropdownbutton/overview/App.jsx

1 Create a Vite + React + TypeScript app

  1. npm create vite@latest my-smart-app -- --template react-ts
  2. cd my-smart-app
    then
    npm install

2 Install Smart UI for React

npm install smart-webcomponents-react

3 Import styles and render the component

Open src/App.tsx (or App.jsx if you chose JavaScript). The snippet below matches Smart UI React demos for this widget:

import 'smart-webcomponents-react/source/styles/smart.default.css';
import './App.css';
import React, { useRef } from "react";
import { Button } from 'smart-webcomponents-react/button';
import { Calendar } from 'smart-webcomponents-react/calendar';
import { DropDownButton } from 'smart-webcomponents-react/dropdownbutton';
import { ListMenu } from 'smart-webcomponents-react/listmenu';
import { SwitchButton } from 'smart-webcomponents-react/switchbutton';

const App = () => {
    const dropdownbutton = useRef(null);

    return (
        <div>
            <div className="demo-description">
                smartDropDownButton allows you to display any type of content in a Drop-down.
            </div>

            <DropDownButton
                ref={dropdownbutton}
                dropDownWidth="auto"
                placeholder="Calendar"
            >
                <Calendar />
            </DropDownButton>

            <DropDownButton dropDownWidth="auto" placeholder="ListMenu">
                <ListMenu
                    dataSource={[
                        {
                            label: 'OSI',
                            items: [
                                {
                                    label: 'Application Layer',
                                    items: [{ label: 'SIP' }, { label: 'DNS' }, { label: 'FTP' }, { label: 'RTP' }, { label: 'DHCP' }]
                                },
                                {
                                    label: 'Presentation Layer',
                                    items: [{ label: 'SSL' }, { label: 'TLS' }]
                                },
                                {
                                    label: 'Session Layer',
                                    items: [{ label: 'NetBIOS' }, { label: 'SPDY' }]
                                },
                                {
                                    label: 'Transport Layer',
                                    items: [{ label: 'TCP' }, { label: 'UDP' }, { label: 'SCTP' }]
                                },
                                {
                                    label: 'Network Layer',
                                    items: [{ label: 'IP' }, { label: 'ARP' }, { label: 'ICMP' }]
                                },
                                {
                                    label: 'Data Link Layer',
                                    items: [{ label: 'ATM' }, { label: 'SDLS' }, { label: 'LLC' }]
                                },
                                {
                                    label: 'Physical Layer',
                                    items: [{ label: 'EIA/TIA-232' }, { label: 'ITU-T V-Series' }, { label: 'DSL' }]
                                }
                            ]
                        },
                        {
                            label: 'TCP/IP',
                            items: [
                                {
                                    label: 'Application Layer',
                                    items: [
                                        { label: 'DHCP' }, { label: 'DNS' }, { label: 'FTP' }, { label: 'HTTP' },
                                        { label: 'IMAP' }, { label: 'LDAP' }, { label: 'XMPP' }, { label: 'SSH' }, { label: 'RIP' }
                                    ]
                                },
                                {
                                    label: 'Transport Layer',
                                    items: [{ label: 'TCP' }, { label: 'UDP' }, { label: 'SCTP' }]
                                },
                                {
                                    label: 'Internet Layer',
                                    items: [{ label: 'IP' }, { label: 'ICMP' }, { label: 'ECN' }]
                                },
                                {
                                    label: 'Link Layer',
                                    items: [{ label: 'ARP' }, { label: 'NDP' }, { label: 'DSL' }]
                                }
                            ]
                        }
                    ]}
                />
            </DropDownButton>

            <DropDownButton placeholder="Buttons">
                <Button>Button</Button>
                <SwitchButton>Switch Button</SwitchButton>
            </DropDownButton>

            <DropDownButton placeholder="Text">
                What is Lorem Ipsum? Lorem Ipsum is simply dummy text of the printing
                and typesetting industry. Lorem Ipsum has been the industry's standard
                dummy text ever since the 1500s, when an unknown printer took a galley
                of type and scrambled it to make a type specimen book. It has survived
                not only five centuries, but also the leap into electronic typesetting,
                remaining essentially unchanged. It was popularised in the 1960s with the
                release of Letraset sheets containing Lorem Ipsum passages, and more recently
                with desktop publishing software like Aldus PageMaker including versions of Lorem Ipsum.
            </DropDownButton>
        </div>
    );
};

export default App;

4 Run the dev server

npm run dev

Open the URL Vite prints (often http://localhost:5173/).

Alternative: Next.js

Create an app with npx create-next-app@latest (Pages Router or App Router). Install the same package (npm install smart-webcomponents-react), then reuse the imports and default export from step 3 in pages/_app.tsx, the App Router root app/layout.tsx, or your top-level layout component so styles and the widget tree load once.

TypeScript Support

Types ship with smart-webcomponents-react. Import the component and prop types:

import type { DropDownButton, DropDownButtonProps } from 'smart-webcomponents-react/dropdownbutton';

The generated wrappers expose on* callbacks (for example onChange) whose arguments are standard DOM Event values unless the widget typings narrow them further.

Accessibility

The DropDownButton component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Angular DropDownButton - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/dropdownbutton/overview

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import DropDownButtonModule from smart-webcomponents-angular/dropdownbutton: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { DropDownButtonModule } from 'smart-webcomponents-angular/dropdownbutton';

4 Root component (standalone)

Add DropDownButtonModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, ViewChild, OnInit, AfterViewInit } from '@angular/core';
import { DropDownButtonComponent } from 'smart-webcomponents-angular/dropdownbutton';

import { DropDownButtonModule } from "smart-webcomponents-angular/dropdownbutton";

import { ListMenuModule } from "smart-webcomponents-angular/listmenu";

import { ButtonModule } from "smart-webcomponents-angular/button";

import { SwitchButtonModule } from "smart-webcomponents-angular/switchbutton";

import { CalendarModule } from "smart-webcomponents-angular/calendar";

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [CalendarModule, DropDownButtonModule, ListMenuModule, SwitchButtonModule],
  templateUrl: './app.html',
  styleUrl: './app.css'
})

export class App implements AfterViewInit, OnInit {
    @ViewChild('dropdownbutton', { read: DropDownButtonComponent, static: false }) dropdownbutton!: DropDownButtonComponent;
    @ViewChild('dropdownbutton2', { read: DropDownButtonComponent, static: false }) dropdownbutton2!: DropDownButtonComponent;
    @ViewChild('dropdownbutton3', { read: DropDownButtonComponent, static: false }) dropdownbutton3!: DropDownButtonComponent;
    @ViewChild('dropdownbutton4', { read: DropDownButtonComponent, static: false }) dropdownbutton4!: DropDownButtonComponent;


    ngOnInit(): void {
        // onInit code.
    }

    ngAfterViewInit(): void {
        // afterViewInit code.
        this.init();
    }

    init(): void {
        // init code.


        const listMenuDataSource = [
            {
                label: 'OSI',
                items: [
                    {
                        label: 'Application Layer',
                        items: [
                            { label: 'SIP' },
                            { label: 'DNS' },
                            { label: 'FTP' },
                            { label: 'RTP' },
                            { label: 'DHCP' }
                        ]
                    },
                    {
                        label: 'Presentation Layer',
                        items: [
                            { label: 'SSL' },
                            { label: 'TLS' }
                        ]
                    },
                    {
                        label: 'Session Layer',
                        items: [
                            { label: 'NetBIOS' },
                            { label: 'SPDY' }
                        ]
                    },
                    {
                        label: 'Transport Layer',
                        items: [
                            { label: 'TCP' },
                            { label: 'UDP' },
                            { label: 'SCTP' }
                        ]
                    },
                    {
                        label: 'Network Layer',
                        items: [
                            { label: 'IP' },
                            { label: 'ARP' },
                            { label: 'ICMP' }
                        ]
                    },
                    {
                        label: 'Data Link Layer',
                        items: [
                            { label: 'ATM' },
                            { label: 'SDLS' },
                            { label: 'LLC' }
                        ]
                    },
                    {
                        label: 'Physical Layer',
                        items: [
                            { label: 'EIA/TIA-232' },
                            { label: 'ITU-T V-Series' },
                            { label: 'DSL' }
                        ]
                    }
                ]
            },
            {
                label: 'TCP/IP',
                items: [
                    {
                        label: 'Application Layer',
                        items: [
                            { label: 'DHCP' },
                            { label: 'DNS' },
                            { label: 'FTP' },
                            { label: 'HTTP' },
                            { label: 'IMAP' },
                            { label: 'LDAP' },
                            { label: 'XMPP' },
                            { label: 'SSH' },
                            { label: 'RIP' }
                        ]
                    },
                    {
                        label: 'Transport Layer',
                        items: [
                            { label: 'TCP' },
                            { label: 'UDP' },
                            { label: 'SCTP' }
                        ]
                    },
                    {
                        label: 'Internet Layer',
                        items: [
                            { label: 'IP' },
                            { label: 'ICMP' },
                            { label: 'ECN' }
                        ]
                    },
                    {
                        label: 'Link Layer',
                        items: [
                            { label: 'ARP' },
                            { label: 'NDP' },
                            { label: 'DSL' }
                        ]
                    }
                ]
            }
        ];

        const listMenu = document.querySelector('smart-list-menu')
        
        if (listMenu) {
            listMenu.dataSource = listMenuDataSource;
        }

    }
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-drop-down-button as needed:

 <div class="demo-description">smartDropDownButton allows you to display any type of content in a Drop-down.</div>
<smart-drop-down-button
#dropdownbutton drop-down-width="auto" placeholder="Calendar">
    <smart-calendar></smart-calendar>
    </smart-drop-down-button>
    <smart-drop-down-button #dropdownbutton2 drop-down-width="auto" placeholder="ListMenu">
        <smart-list-menu></smart-list-menu>
    </smart-drop-down-button>
    <smart-drop-down-button #dropdownbutton3 placeholder="Buttons">
        <smart-button>Button</smart-button>
        <smart-switch-button>Switch Button</smart-switch-button>
    </smart-drop-down-button>
    <smart-drop-down-button #dropdownbutton4 placeholder="Text">What is Lorem Ipsum? Lorem Ipsum is simply dummy text of the printing
        and typesetting industry. Lorem Ipsum has been the industry's standard
        dummy text ever since the 1500s, when an unknown printer took a galley
        of type and scrambled it to make a type specimen book. It has survived
        not only five centuries, but also the leap into electronic typesetting,
        remaining essentially unchanged. It was popularised in the 1960s with the
        release of Letraset sheets containing Lorem Ipsum passages, and more recently
        with desktop publishing software like Aldus PageMaker including versions
        of Lorem Ipsum.</smart-drop-down-button>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put DropDownButtonModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

The demo sources bundled for this widget use standalone only (there is no app.module.ts in that folder). NgModule is fully supported: put DropDownButtonModule from smart-webcomponents-angular/dropdownbutton on NgModule.imports, make your root component non-standalone (remove standalone: true and move widget modules from @Component.imports to the module), and bootstrap with platformBrowserDynamic().bootstrapModule(AppModule).

Minimal main.ts + app.module.ts pairing (adjust paths to match your CLI layout):

src/main.ts

import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { AppModule } from './app/app.module';

platformBrowserDynamic().bootstrapModule(AppModule).catch((err) => console.error(err));

src/app/app.module.ts

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { DropDownButtonModule } from 'smart-webcomponents-angular/dropdownbutton';

@NgModule({
	declarations: [ AppComponent ],
	imports: [ BrowserModule, DropDownButtonModule ],
	bootstrap: [ AppComponent ]
})
export class AppModule { }

Reuse the template and class logic from steps 4-5 in AppComponent, configured for declarations + NgModule.imports instead of a standalone @Component.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Accessibility

The DropDownButton component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.